## parasail 2.4.3+dfsg

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED( VERSION 3.2 )

FILE( STRINGS parasail.h MAJOR REGEX "^#define +PARASAIL_VERSION_MAJOR +[0-9]+$" )
FILE( STRINGS parasail.h MINOR REGEX "^#define +PARASAIL_VERSION_MINOR +[0-9]+$" )
FILE( STRINGS parasail.h PATCH REGEX "^#define +PARASAIL_VERSION_PATCH +[0-9]+$" )
STRING( REPLACE "#define PARASAIL_VERSION_MAJOR " "" MAJOR ${MAJOR} )
STRING( REPLACE "#define PARASAIL_VERSION_MINOR " "" MINOR ${MINOR} )
STRING( REPLACE "#define PARASAIL_VERSION_PATCH " "" PATCH ${PATCH} )

PROJECT( parasail VERSION ${MAJOR}.${MINOR}.${PATCH} )

SET( CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake" ${CMAKE_MODULE_PATH} )

OPTION( BUILD_SHARED_LIBS "Build Shared Libraries" ON )
SET( LIB_TYPE STATIC )
IF( BUILD_SHARED_LIBS )
  SET( LIB_TYPE SHARED )
  # All OBJECT libraries below are later consumed by a shared library so
  # the following is OK. Saves on setting it as a per target property.
  SET( CMAKE_POSITION_INDEPENDENT_CODE ON )
ENDIF( )

INCLUDE( CheckFunctionExists )
INCLUDE( CheckIncludeFile )
INCLUDE( CheckLibraryExists )
INCLUDE( CheckSymbolExists )
INCLUDE( CheckTypeSize )
INCLUDE( CheckCSourceCompiles )
INCLUDE( FindOpenMP )
INCLUDE( FindSSE2 )
INCLUDE( FindSSE41 )
INCLUDE( FindAVX2 )
INCLUDE( Findxgetbv )
INCLUDE( FindAltiVec )
INCLUDE( FindNEON )
INCLUDE( FindZLIB )
INCLUDE( TestBigEndian )

MESSAGE( STATUS "Check if the CPU is POWER" )
IF( ${CMAKE_SYSTEM_PROCESSOR} MATCHES "p(ower)?pc" )
    SET( IS_POWER_ISA TRUE )
    MESSAGE( STATUS "Check if the CPU is POWER - TRUE" )
ELSE( )
    SET( IS_POWER_ISA FALSE )
    MESSAGE( STATUS "Check if the CPU is POWER - FALSE" )
ENDIF( )

MESSAGE( STATUS "Check if the CPU is ARM" )
IF( ${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm.*" OR ${CMAKE_SYSTEM_PROCESSOR} MATCHES "aarch64.*" )
    SET( IS_ARM_ISA TRUE )
    MESSAGE( STATUS "Check if the CPU is ARM - TRUE" )
ELSE( )
    SET( IS_ARM_ISA FALSE )
    MESSAGE( STATUS "Check if the CPU is ARM - FALSE" )
ENDIF( )

CHECK_TYPE_SIZE( "int" SIZEOF_INT )
CHECK_TYPE_SIZE( "int8_t" SIZEOF_INT8_T )
CHECK_TYPE_SIZE( "int16_t" SIZEOF_INT16_T )
CHECK_TYPE_SIZE( "int32_t" SIZEOF_INT32_T )
CHECK_TYPE_SIZE( "int64_t" SIZEOF_INT64_T )
CHECK_TYPE_SIZE( "uint8_t" SIZEOF_UINT8_T )
CHECK_TYPE_SIZE( "uint16_t" SIZEOF_UINT16_T )
CHECK_TYPE_SIZE( "uint32_t" SIZEOF_UINT32_T )
CHECK_TYPE_SIZE( "uint64_t" SIZEOF_UINT64_T )
TEST_BIG_ENDIAN( WORDS_BIGENDIAN )

# Check for restrict keyword
FOREACH( ac_kw __restrict __restrict__ _Restrict restrict )
    CHECK_C_SOURCE_COMPILES(
"
typedef int * int_ptr;
int foo (int_ptr ${ac_kw} ip) {
    return ip[0];
}
int main() {
    int s[1];
    int * ${ac_kw} t = s;
    t[0] = 0;
    return foo(t);
}
"
    HAVE_RESTRICT )
    IF( HAVE_RESTRICT )
        SET( ac_cv_c_restrict ${ac_kw} )
        BREAK( )
    ENDIF( )
ENDFOREACH( )
IF( HAVE_RESTRICT )
    SET( restrict ${ac_cv_c_restrict} )
ELSE( )
    SET( restrict " " )
ENDIF( )

# Check for inline keyword
CHECK_C_SOURCE_COMPILES(
"
typedef int foo_t;
static inline foo_t static_foo(){return 0;}
foo_t foo(){return 0;}
int main(int argc, char *argv[]){return 0;}
"
    HAVE_INLINE_NATIVE )
IF( HAVE_INLINE_NATIVE )
ELSE ( )
    FOREACH( ac_kw __inline__ __inline )
        CHECK_C_SOURCE_COMPILES(
"
typedef int foo_t;
static ${ac_kw} foo_t static_foo(){return 0;}
foo_t foo(){return 0;}
int main(int argc, char *argv[]){return 0;}
"
        HAVE_INLINE )
        IF( HAVE_INLINE )
            SET( ac_cv_c_inline ${ac_kw} )
            BREAK( )
        ENDIF( )
    ENDFOREACH( )
    IF( HAVE_INLINE )
        SET( inline ${ac_cv_c_inline} )
    ELSE( )
        SET( inline " " )
    ENDIF( )
ENDIF( )

SET( CMAKE_REQUIRED_INCLUDES stdint.h )

INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_LIST_DIR} )
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_LIST_DIR}/contrib )
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_LIST_DIR}/contrib/sais-lite-lcp )
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_LIST_DIR}/contrib/ssw )
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_LIST_DIR}/src )
INCLUDE_DIRECTORIES( ${CMAKE_BINARY_DIR} )
IF( NEON_FOUND )
INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_LIST_DIR}/contrib/simde/simde )
ENDIF( )

CHECK_INCLUDE_FILE( sys/mman.h HAVE_SYS_MMAN_H )
CHECK_INCLUDE_FILE( unistd.h HAVE_UNISTD_H )
CHECK_INCLUDE_FILE( windows.h HAVE_WINDOWS_H )

#CHECK_FUNCTION_EXISTS( _aligned_malloc HAVE__ALIGNED_MALLOC )
#CHECK_FUNCTION_EXISTS( posix_memalign HAVE_POSIX_MEMALIGN )
#CHECK_FUNCTION_EXISTS( aligned_alloc HAVE_ALIGNED_ALLOC )
#CHECK_FUNCTION_EXISTS( memalign HAVE_MEMALIGN )
CHECK_SYMBOL_EXISTS( _aligned_malloc malloc.h HAVE__ALIGNED_MALLOC )
CHECK_SYMBOL_EXISTS( posix_memalign stdlib.h HAVE_POSIX_MEMALIGN )
CHECK_SYMBOL_EXISTS( aligned_alloc stdlib.h HAVE_ALIGNED_ALLOC )
CHECK_SYMBOL_EXISTS( memalign malloc.h HAVE_MEMALIGN )
CHECK_FUNCTION_EXISTS( getopt HAVE_GETOPT )
CHECK_FUNCTION_EXISTS( poll HAVE_POLL )
#CHECK_FUNCTION_EXISTS( filelength HAVE_FILELENGTH )
#CHECK_FUNCTION_EXISTS( GetSystemTimeAsFileTime HAVE_GETSYSTEMTIMEASFILETIME )
#CHECK_FUNCTION_EXISTS( SetUnhandledExceptionFilter HAVE_SETUNHANDLEDEXCEPTIONFILTER )
CHECK_SYMBOL_EXISTS( filelength io.h HAVE_FILELENGTH )
CHECK_SYMBOL_EXISTS( GetSystemTimeAsFileTime windows.h HAVE_GETSYSTEMTIMEASFILETIME )
CHECK_SYMBOL_EXISTS( SetUnhandledExceptionFilter windows.h HAVE_SETUNHANDLEDEXCEPTIONFILTER )
CHECK_FUNCTION_EXISTS( clock_get_time HAVE_CLOCK_GET_TIME_NATIVE )
CHECK_FUNCTION_EXISTS( clock_gettime HAVE_CLOCK_GETTIME_NATIVE )
CHECK_LIBRARY_EXISTS( rt clock_gettime "" HAVE_CLOCK_GETTIME_RT )
CHECK_LIBRARY_EXISTS( pthread clock_gettime "" HAVE_CLOCK_GETTIME_PTHREAD )
CHECK_FUNCTION_EXISTS( sqrt HAVE_SQRT_NATIVE )
CHECK_LIBRARY_EXISTS( m sqrt "" HAVE_SQRT_M )

CONFIGURE_FILE( ${CMAKE_CURRENT_LIST_DIR}/cmake/config.h.in ${CMAKE_BINARY_DIR}/config.h )

SET( SRC_CORE
    src/cigar.c
    src/function_lookup.c
    src/io.c
    src/isastubs.c
    src/matrix_lookup.c
    src/memory.c
    src/parser.c
    src/pssw.c
    src/time.c
    src/nw_dispatch.c
    src/sg_dispatch.c
    src/sw_dispatch.c
    src/sg_qb_dispatch.c
    src/sg_qe_dispatch.c
    src/sg_qx_dispatch.c
    src/sg_db_dispatch.c
    src/sg_de_dispatch.c
    src/sg_dx_dispatch.c
    src/sg_qb_de_dispatch.c
    src/sg_qe_db_dispatch.c
    src/dispatch_profile.c
    src/satcheck.c
    src/striped_unwind.c
    src/traceback.c
)

IF( IS_POWER_ISA )
    SET( SRC_CORE ${SRC_CORE} src/cpuid_ppc.c )
ELSEIF( IS_ARM_ISA )
    SET( SRC_CORE ${SRC_CORE} src/cpuid_arm.c )
ELSE( )
    SET( SRC_CORE ${SRC_CORE} src/cpuid.c )
ENDIF( )

SET( SRC_NOVEC
    src/nw.c
    src/sg.c
    src/sw.c
    src/nw_banded.c
    src/nw_scan.c
    src/sg_scan.c
    src/sw_scan.c
    src/nw_stats.c
    src/sg_stats.c
    src/sw_stats.c
    src/nw_stats_scan.c
    src/sg_stats_scan.c
    src/sw_stats_scan.c
)

SET( SRC_TRACE_NOVEC
    src/nw_trace.c
    src/sg_trace.c
    src/sw_trace.c
    src/nw_trace_scan.c
    src/sg_trace_scan.c
    src/sw_trace_scan.c
)

SET( SRC_SSE2
    src/nw_scan_sse2_128_64.c
    src/sg_scan_sse2_128_64.c
    src/sw_scan_sse2_128_64.c
    src/nw_scan_sse2_128_32.c
    src/sg_scan_sse2_128_32.c
    src/sw_scan_sse2_128_32.c
    src/nw_scan_sse2_128_16.c
    src/sg_scan_sse2_128_16.c
    src/sw_scan_sse2_128_16.c
    src/nw_scan_sse2_128_8.c
    src/sg_scan_sse2_128_8.c
    src/sw_scan_sse2_128_8.c
    src/nw_diag_sse2_128_64.c
    src/sg_diag_sse2_128_64.c
    src/sw_diag_sse2_128_64.c
    src/nw_diag_sse2_128_32.c
    src/sg_diag_sse2_128_32.c
    src/sw_diag_sse2_128_32.c
    src/nw_diag_sse2_128_16.c
    src/sg_diag_sse2_128_16.c
    src/sw_diag_sse2_128_16.c
    src/nw_diag_sse2_128_8.c
    src/sg_diag_sse2_128_8.c
    src/sw_diag_sse2_128_8.c
    src/nw_striped_sse2_128_64.c
    src/sg_striped_sse2_128_64.c
    src/sw_striped_sse2_128_64.c
    src/nw_striped_sse2_128_32.c
    src/sg_striped_sse2_128_32.c
    src/sw_striped_sse2_128_32.c
    src/nw_striped_sse2_128_16.c
    src/sg_striped_sse2_128_16.c
    src/sw_striped_sse2_128_16.c
    src/nw_striped_sse2_128_8.c
    src/sg_striped_sse2_128_8.c
    src/sw_striped_sse2_128_8.c
    src/nw_stats_scan_sse2_128_64.c
    src/sg_stats_scan_sse2_128_64.c
    src/sw_stats_scan_sse2_128_64.c
    src/nw_stats_scan_sse2_128_32.c
    src/sg_stats_scan_sse2_128_32.c
    src/sw_stats_scan_sse2_128_32.c
    src/nw_stats_scan_sse2_128_16.c
    src/sg_stats_scan_sse2_128_16.c
    src/sw_stats_scan_sse2_128_16.c
    src/nw_stats_scan_sse2_128_8.c
    src/sg_stats_scan_sse2_128_8.c
    src/sw_stats_scan_sse2_128_8.c
    src/nw_stats_diag_sse2_128_64.c
    src/sg_stats_diag_sse2_128_64.c
    src/sw_stats_diag_sse2_128_64.c
    src/nw_stats_diag_sse2_128_32.c
    src/sg_stats_diag_sse2_128_32.c
    src/sw_stats_diag_sse2_128_32.c
    src/nw_stats_diag_sse2_128_16.c
    src/sg_stats_diag_sse2_128_16.c
    src/sw_stats_diag_sse2_128_16.c
    src/nw_stats_diag_sse2_128_8.c
    src/sg_stats_diag_sse2_128_8.c
    src/sw_stats_diag_sse2_128_8.c
    src/nw_stats_striped_sse2_128_64.c
    src/sg_stats_striped_sse2_128_64.c
    src/sw_stats_striped_sse2_128_64.c
    src/nw_stats_striped_sse2_128_32.c
    src/sg_stats_striped_sse2_128_32.c
    src/sw_stats_striped_sse2_128_32.c
    src/nw_stats_striped_sse2_128_16.c
    src/sg_stats_striped_sse2_128_16.c
    src/sw_stats_striped_sse2_128_16.c
    src/nw_stats_striped_sse2_128_8.c
    src/sg_stats_striped_sse2_128_8.c
    src/sw_stats_striped_sse2_128_8.c
)

SET( SRC_TRACE_SSE2
    src/nw_trace_scan_sse2_128_64.c
    src/sg_trace_scan_sse2_128_64.c
    src/sw_trace_scan_sse2_128_64.c
    src/nw_trace_scan_sse2_128_32.c
    src/sg_trace_scan_sse2_128_32.c
    src/sw_trace_scan_sse2_128_32.c
    src/nw_trace_scan_sse2_128_16.c
    src/sg_trace_scan_sse2_128_16.c
    src/sw_trace_scan_sse2_128_16.c
    src/nw_trace_scan_sse2_128_8.c
    src/sg_trace_scan_sse2_128_8.c
    src/sw_trace_scan_sse2_128_8.c
    src/nw_trace_diag_sse2_128_64.c
    src/sg_trace_diag_sse2_128_64.c
    src/sw_trace_diag_sse2_128_64.c
    src/nw_trace_diag_sse2_128_32.c
    src/sg_trace_diag_sse2_128_32.c
    src/sw_trace_diag_sse2_128_32.c
    src/nw_trace_diag_sse2_128_16.c
    src/sg_trace_diag_sse2_128_16.c
    src/sw_trace_diag_sse2_128_16.c
    src/nw_trace_diag_sse2_128_8.c
    src/sg_trace_diag_sse2_128_8.c
    src/sw_trace_diag_sse2_128_8.c
    src/nw_trace_striped_sse2_128_64.c
    src/sg_trace_striped_sse2_128_64.c
    src/sw_trace_striped_sse2_128_64.c
    src/nw_trace_striped_sse2_128_32.c
    src/sg_trace_striped_sse2_128_32.c
    src/sw_trace_striped_sse2_128_32.c
    src/nw_trace_striped_sse2_128_16.c
    src/sg_trace_striped_sse2_128_16.c
    src/sw_trace_striped_sse2_128_16.c
    src/nw_trace_striped_sse2_128_8.c
    src/sg_trace_striped_sse2_128_8.c
    src/sw_trace_striped_sse2_128_8.c
)

SET( SRC_SSE41
    src/nw_scan_sse41_128_64.c
    src/sg_scan_sse41_128_64.c
    src/sw_scan_sse41_128_64.c
    src/nw_scan_sse41_128_32.c
    src/sg_scan_sse41_128_32.c
    src/sw_scan_sse41_128_32.c
    src/nw_scan_sse41_128_16.c
    src/sg_scan_sse41_128_16.c
    src/sw_scan_sse41_128_16.c
    src/nw_scan_sse41_128_8.c
    src/sg_scan_sse41_128_8.c
    src/sw_scan_sse41_128_8.c
    src/nw_diag_sse41_128_64.c
    src/sg_diag_sse41_128_64.c
    src/sw_diag_sse41_128_64.c
    src/nw_diag_sse41_128_32.c
    src/sg_diag_sse41_128_32.c
    src/sw_diag_sse41_128_32.c
    src/nw_diag_sse41_128_16.c
    src/sg_diag_sse41_128_16.c
    src/sw_diag_sse41_128_16.c
    src/nw_diag_sse41_128_8.c
    src/sg_diag_sse41_128_8.c
    src/sw_diag_sse41_128_8.c
    src/nw_striped_sse41_128_64.c
    src/sg_striped_sse41_128_64.c
    src/sw_striped_sse41_128_64.c
    src/nw_striped_sse41_128_32.c
    src/sg_striped_sse41_128_32.c
    src/sw_striped_sse41_128_32.c
    src/nw_striped_sse41_128_16.c
    src/sg_striped_sse41_128_16.c
    src/sw_striped_sse41_128_16.c
    src/nw_striped_sse41_128_8.c
    src/sg_striped_sse41_128_8.c
    src/sw_striped_sse41_128_8.c
    src/sw_blocked_sse41_128_32.c
    src/sw_blocked_sse41_128_16.c
    src/nw_stats_scan_sse41_128_64.c
    src/sg_stats_scan_sse41_128_64.c
    src/sw_stats_scan_sse41_128_64.c

=== meson_options.txt ===
option('sse2',
  type : 'boolean',
  value : true,
  description : 'Build SSE2 routines')

option('sse41',
  type : 'boolean',
  value : true,
  description : 'Build SSE4.1 routines')

option('avx2',
  type : 'boolean',
  value : true,
  description : 'Build AVX2 routines')

## parasail 2.4.2+dfsg

=== debian/changelog ===
parasail (2.4.2+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Provide symbols file for amd64 only to decrease maintenance burden
    Closes: #958157

 -- Andreas Tille <tille@debian.org>  Tue, 21 Apr 2020 09:52:31 +0200

parasail (2.4.2+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Add salsa-ci file (routine-update)
  * debian/copyright: use spaces rather than tabs to start continuation
    lines.
  * Set field Upstream-Contact in debian/copyright.
  * Set upstream metadata fields: Bug-Submit.
  * Remove obsolete fields Contact, Name from debian/upstream/metadata
    (already present in machine-readable debian/copyright).

 -- Andreas Tille <tille@debian.org>  Sat, 18 Apr 2020 06:43:38 +0200

parasail (2.4.1+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #956417)

 -- Nilesh Patra <npatra974@gmail.com>  Sat, 18 Apr 2020 01:26:34 +0530

=== debian/control ===
Source: parasail
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Nilesh Patra <npatra974@gmail.com>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 12),
               libhts-dev,
               libsimde-dev
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/parasail
Vcs-Git: https://salsa.debian.org/med-team/parasail.git
Homepage: https://github.com/jeffdaily/parasail
Rules-Requires-Root: no

Package: libparasail-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libparasail3 (= ${binary:Version}),
         ${misc:Depends}
Description: Development heaaders and static libraries for parasail
 This package provides development headers and static libraries for
 parasail. It is a SIMD C library containing implementations of the
 Smith-Waterman, Needleman-Wunsch, and various semi-global pairwise
 sequence alignment algorithm.

Package: libparasail3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Lib with various pairwise sequence alignment algorithms
 parasail is a SIMD C (C99) library containing implementations of
 the Smith-Waterman, Needleman-Wunsch, and various semi-global
 pairwise sequence alignment algorithms. Parasail implements most
 known algorithms for vectorized pairwise sequence alignment,
 including diagonal, blocked, striped, and prefix scan.

Package: parasail
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libparasail3
Description: Aligner based on libparasail3
 This package contains a command-line aligner based on
 libparasail3. Parasail is a SIMD C library containing
 implementations of the Smith-Waterman, Needleman-Wunsch,
 and various semi-global pairwise sequence alignment algorithm.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
                --enable-shared \
		--disable-static

override_dh_fixperms:
	dh_fixperms
	find debian -name "*.c" -exec chmod -x \{\} \;

## parasail 2.4.3%2Bdfsg

=== debian/rules ===
--- 
+++ 
@@ -17,3 +17,7 @@
 override_dh_fixperms:
 	dh_fixperms
 	find debian -name "*.c" -exec chmod -x \{\} \;
+
+override_dh_missing:
+	find debian -name '*.la' | xargs rm -rf
+	dh_missing

## parasail 2.4.3+dfsg

=== debian/changelog ===
parasail (2.4.3+dfsg-2) unstable; urgency=medium

  * Team upload.
  * debian/patches/nonx86: fix compilation on non-x86, non-arm, non-powerpc
  * No tab in license text (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 27 Jan 2021 17:29:31 +0100

parasail (2.4.3+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove useless .la files

 -- Nilesh Patra <npatra974@gmail.com>  Fri, 27 Nov 2020 17:47:39 +0530

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Uploaders: Nilesh Patra <npatra974@gmail.com>
 Section: libs
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                libhts-dev,
                libsimde-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/parasail
 Vcs-Git: https://salsa.debian.org/med-team/parasail.git
 Homepage: https://github.com/jeffdaily/parasail

=== debian/watch ===
version=4
opts=\
repacksuffix=+dfsg,\
repack,compression=xz,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,\
filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/parasail-$1\.tar\.gz/ \
  https://github.com/jeffdaily/parasail/tags .*/v?(\d\S+)\.tar\.gz

## parasail 2.5+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -26,7 +26,6 @@
 INCLUDE( CheckSymbolExists )
 INCLUDE( CheckTypeSize )
 INCLUDE( CheckCSourceCompiles )
-INCLUDE( FindOpenMP )
 INCLUDE( FindSSE2 )
 INCLUDE( FindSSE41 )
 INCLUDE( FindAVX2 )
@@ -36,23 +35,10 @@
 INCLUDE( FindZLIB )
 INCLUDE( TestBigEndian )
 
-MESSAGE( STATUS "Check if the CPU is POWER" )
-IF( ${CMAKE_SYSTEM_PROCESSOR} MATCHES "p(ower)?pc" )
-    SET( IS_POWER_ISA TRUE )
-    MESSAGE( STATUS "Check if the CPU is POWER - TRUE" )
-ELSE( )
-    SET( IS_POWER_ISA FALSE )
-    MESSAGE( STATUS "Check if the CPU is POWER - FALSE" )
-ENDIF( )
-
-MESSAGE( STATUS "Check if the CPU is ARM" )
-IF( ${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm.*" OR ${CMAKE_SYSTEM_PROCESSOR} MATCHES "aarch64.*" )
-    SET( IS_ARM_ISA TRUE )
-    MESSAGE( STATUS "Check if the CPU is ARM - TRUE" )
-ELSE( )
-    SET( IS_ARM_ISA FALSE )
-    MESSAGE( STATUS "Check if the CPU is ARM - FALSE" )
-ENDIF( )
+OPTION( WITH_OPENMP "Enable OpenMP (if supported by the compiler)" ON )
+IF( WITH_OPENMP )
+  INCLUDE( FindOpenMP )
+ENDIF()
 
 CHECK_TYPE_SIZE( "int" SIZEOF_INT )
 CHECK_TYPE_SIZE( "int8_t" SIZEOF_INT8_T )
@@ -65,17 +51,26 @@
 CHECK_TYPE_SIZE( "uint64_t" SIZEOF_UINT64_T )
 TEST_BIG_ENDIAN( WORDS_BIGENDIAN )
 
+# Check for __builtin_cpu_init
+CHECK_C_SOURCE_COMPILES("int main () { __builtin_cpu_init(); return 0; } "
+HAVE___BUILTIN_CPU_INIT )
+
+# Check for __builtin_cpu_supports
+CHECK_C_SOURCE_COMPILES("int main () { __builtin_cpu_supports(\"sse\"); return 0; } "
+HAVE___BUILTIN_CPU_SUPPORTS )
+
 # Check for restrict keyword
 FOREACH( ac_kw __restrict __restrict__ _Restrict restrict )
     CHECK_C_SOURCE_COMPILES(
 "
+#define restrict ${ac_kw}
 typedef int * int_ptr;
-int foo (int_ptr ${ac_kw} ip) {
+int foo (int_ptr restrict ip) {
     return ip[0];
 }
 int main() {
     int s[1];
-    int * ${ac_kw} t = s;
+    int * restrict t = s;
     t[0] = 0;
     return foo(t);
 }
@@ -84,12 +79,16 @@
     IF( HAVE_RESTRICT )
         SET( ac_cv_c_restrict ${ac_kw} )
         BREAK( )
+    ELSE( )
+        UNSET( HAVE_RESTRICT CACHE )
     ENDIF( )
 ENDFOREACH( )
 IF( HAVE_RESTRICT )
     SET( restrict ${ac_cv_c_restrict} )
+    SET( parasail_safe_restrict_cxx ${ac_cv_c_restrict} )
 ELSE( )
     SET( restrict " " )
+    SET( parasail_safe_restrict_cxx " ")
 ENDIF( )
 
 # Check for inline keyword
@@ -115,6 +114,8 @@
         IF( HAVE_INLINE )
             SET( ac_cv_c_inline ${ac_kw} )
             BREAK( )
+        ELSE( )
+            UNSET( HAVE_INLINE CACHE )
         ENDIF( )
     ENDFOREACH( )
     IF( HAVE_INLINE )
@@ -150,6 +151,7 @@
 CHECK_SYMBOL_EXISTS( memalign malloc.h HAVE_MEMALIGN )
 CHECK_FUNCTION_EXISTS( getopt HAVE_GETOPT )
 CHECK_FUNCTION_EXISTS( poll HAVE_POLL )
+#CHECK_FUNCTION_EXISTS( __builtin_cpu_supports HAVE___BUILTIN_CPU_SUPPORTS )
 #CHECK_FUNCTION_EXISTS( filelength HAVE_FILELENGTH )
 #CHECK_FUNCTION_EXISTS( GetSystemTimeAsFileTime HAVE_GETSYSTEMTIMEASFILETIME )
 #CHECK_FUNCTION_EXISTS( SetUnhandledExceptionFilter HAVE_SETUNHANDLEDEXCEPTIONFILTER )
@@ -167,6 +169,7 @@
 
 SET( SRC_CORE
     src/cigar.c
+    src/cpuid.c
     src/function_lookup.c
     src/io.c
     src/isastubs.c
@@ -191,14 +194,6 @@
     src/striped_unwind.c
     src/traceback.c
 )
-
-IF( IS_POWER_ISA )
-    SET( SRC_CORE ${SRC_CORE} src/cpuid_ppc.c )
-ELSEIF( IS_ARM_ISA )
-    SET( SRC_CORE ${SRC_CORE} src/cpuid_arm.c )
-ELSE( )
-    SET( SRC_CORE ${SRC_CORE} src/cpuid.c )
-ENDIF( )
 
 SET( SRC_NOVEC
     src/nw.c
@@ -381,3 +376,5 @@
     src/nw_stats_scan_sse41_128_64.c
     src/sg_stats_scan_sse41_128_64.c
     src/sw_stats_scan_sse41_128_64.c
+    src/nw_stats_scan_sse41_128_32.c
+    src/sg_stats_scan_sse41_128_32.c

=== debian/changelog ===
parasail (2.5+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Use DEB_HOST_MULTIARCH instead of x86_64-linux-gnu
  * Enable build on non-amd64 architectures
    Closes: #1004650

 -- Andreas Tille <tille@debian.org>  Mon, 31 Jan 2022 07:24:24 +0100

parasail (2.5+dfsg-2) unstable; urgency=medium

  * Source only upload.

 -- Andreas Tille <tille@debian.org>  Sat, 29 Jan 2022 07:46:40 +0100

parasail (2.5+dfsg-1) experimental; urgency=medium

  * Team upload.
  * d/watch: Do not report pre-releases
  * Standards-Version: 4.6.0 (routine-update)
  * Avoid explicitly specifying -Wl,--as-needed linker flag.
  * Source package: Section: science
  * Use d-shlibs to detect SONAME changes more easily
  * Update symbols file

 -- Andreas Tille <tille@debian.org>  Thu, 27 Jan 2022 12:31:51 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: parasail
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Nilesh Patra <npatra974@gmail.com>
-Section: libs
+Uploaders: Nilesh Patra <nilesh@debian.org>
+Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
+               d-shlibs,
                libhts-dev,
                libsimde-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/parasail
 Vcs-Git: https://salsa.debian.org/med-team/parasail.git
 Homepage: https://github.com/jeffdaily/parasail
@@ -16,7 +17,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libparasail3 (= ${binary:Version}),
+Depends: libparasail8 (= ${binary:Version}),
          ${misc:Depends}
 Description: Development heaaders and static libraries for parasail
  This package provides development headers and static libraries for
@@ -24,8 +25,9 @@
  Smith-Waterman, Needleman-Wunsch, and various semi-global pairwise
  sequence alignment algorithm.
 
-Package: libparasail3
+Package: libparasail8
 Architecture: any
+Section: libs
 Multi-Arch: same
 Depends: ${shlibs:Depends},
          ${misc:Depends}
@@ -40,9 +42,9 @@
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         libparasail3
-Description: Aligner based on libparasail3
+         libparasail8
+Description: Aligner based on libparasail
  This package contains a command-line aligner based on
- libparasail3. Parasail is a SIMD C library containing
+ libparasail. Parasail is a SIMD C library containing
  implementations of the Smith-Waterman, Needleman-Wunsch,
  and various semi-global pairwise sequence alignment algorithm.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
                --enable-shared \
		--disable-static

override_dh_install:
	dh_install
	mv `find .libs -name "libparasail*.a" | head -n1` debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libparasail.a
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --movedev debian/tmp/usr/include usr \
		    --movedev "debian/tmp/usr/lib/*/pkgconfig/*.pc" usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
		    debian/tmp/usr/lib/*/*.so
	rm debian/libparasail-dev/usr/lib/$(DEB_HOST_MULTIARCH)/libparasail.a
	dh_install -p libparasail-dev .libs/*.a usr/lib/$(DEB_HOST_MULTIARCH)
	find debian -name "lib*.la" -delete

override_dh_fixperms:
	dh_fixperms
	find debian -name "*.c" -exec chmod -x \{\} \;

## parasail 2.6+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -189,6 +189,8 @@
     src/sg_dx_dispatch.c
     src/sg_qb_de_dispatch.c
     src/sg_qe_db_dispatch.c
+    src/sg_qb_db_dispatch.c
+    src/sg_qe_de_dispatch.c
     src/dispatch_profile.c
     src/satcheck.c
     src/striped_unwind.c
@@ -377,4 +379,3 @@
     src/sg_stats_scan_sse41_128_64.c
     src/sw_stats_scan_sse41_128_64.c
     src/nw_stats_scan_sse41_128_32.c
-    src/sg_stats_scan_sse41_128_32.c

=== contrib/sais-lite-lcp/Makefile ===
# Makefile for suftest and test

# options
CC						= llvm-gcc
#CXX						= g++
#OUTPUT_OPTION	= -o $@
CFLAGS                          = -ffast-math -O9 -funroll-loops -DNDEBUG
#CFLAGS				= -O3 -fomit-frame-pointer -funroll-loops
#CXXFLAGS			= -O3 -fomit-frame-pointer
CPPFLAGS			= -Wall -DNDEBUG
#CPPFLAGS			= -Wall
LDFLAGS				= 
LDLIBS				= 
#TARGET_ARCH		=

# targets
.PHONY: all
all: suftest
suftest: sais.o suftest.o
test:
	$(CC) -O -g -Wall test.c sais.c -o test
	./test
	$(RM) test test.exe

distclean: clean
clean:
	$(RM) suftest suftest.exe test test.exe sais.o suftest.o

# dependencies
sais.o suftest.o: sais.h Makefile

=== debian/changelog ===
parasail (2.6+dfsg-1) unstable; urgency=medium

  * New upstream version
  * d/control: add myself to uploaders.
  * Standards-Version: 4.6.1 (routine-update)
  * vectorization.patch: delete; applied upstream.
  * d/libparasail8.symbols.amd64: new symbols introduced.

 -- Étienne Mollier <emollier@debian.org>  Thu, 08 Sep 2022 22:35:34 +0200

parasail (2.5+dfsg-4) unstable; urgency=medium

  * Team upload.
  * d/rules: temporarily disable Neon support for Arm due to FTBFS.
  * Add vectorization.patch: fix SIMD compiler support detection with -Wall.
  * d/rules: disable amd64 only simd extension on i386.
  * d/rules: cp a library instead of mv; fix random static library
    disappearing from the build.
    (Closes: #1010276)
  * d/rules: flag false positive blhc warnings in configure output.

 -- Étienne Mollier <emollier@debian.org>  Sun, 01 May 2022 13:27:24 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: parasail
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Nilesh Patra <nilesh@debian.org>
+Uploaders: Nilesh Patra <nilesh@debian.org>,
+           Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                d-shlibs,
                libhts-dev,
                libsimde-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/parasail
 Vcs-Git: https://salsa.debian.org/med-team/parasail.git
 Homepage: https://github.com/jeffdaily/parasail

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

# Don't build excessive SIMD variants which never made it on 32bit x86.
ifeq ($(DEB_HOST_ARCH), i386)
SIMD_FLAGS = --disable-avx512 --disable-avx2 --disable-sse4_1
endif

# FIXME: Arm platforms FTBFS when Neon support is enabled, so disable for now.
ifneq ($(filter $(DEB_HOST_ARCH),armel armhf arm64),)
SIMD_FLAGS = --disable-neon
endif

%:
	dh $@

override_dh_auto_configure:
	@ echo 'blhc: ignore-line-regexp:     C(C|XX) : \.+ .*'
	dh_auto_configure -- $(SIMD_FLAGS) \
                --enable-shared \
		--disable-static

override_dh_install:
	dh_install
	cp `find .libs -name "libparasail*.a" | head -n1` \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libparasail.a
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --movedev debian/tmp/usr/include usr \
		    --movedev "debian/tmp/usr/lib/*/pkgconfig/*.pc" \
	                      usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
		    debian/tmp/usr/lib/*/*.so
	rm debian/libparasail-dev/usr/lib/$(DEB_HOST_MULTIARCH)/libparasail.a
	dh_install -p libparasail-dev .libs/*.a usr/lib/$(DEB_HOST_MULTIARCH)
	find debian -name "lib*.la" -delete

override_dh_fixperms:
	dh_fixperms
	find debian -name "*.c" -exec chmod -x \{\} \;

## parasail 2.6.2+dfsg

=== debian/changelog ===
parasail (2.6.2+dfsg-2ubuntu2) questing; urgency=medium

  * d/rules: remove t64, missed removing while merging.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 07 May 2025 21:57:09 +0100

parasail (2.6.2+dfsg-2ubuntu1) plucky; urgency=medium

  * Merge from Debian Unstable. Remaining changes:
    - Instead of keeping the package revert, bring it back in sync with Debian
      and modify the Breaks/Conflicts/Replaces which need to be kept until the
      next LTS.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Wed, 19 Feb 2025 21:35:58 -0600

parasail (2.6.2+dfsg-2) unstable; urgency=medium

  * gcc-14.patch: new: fix incompatible pointer types. (Closes: #1075361)
  * d/control: declare compliance to standards version 4.7.0.

 -- Étienne Mollier <emollier@debian.org>  Fri, 16 Aug 2024 09:03:57 +0200

parasail (2.6.2+dfsg-1ubuntu2) noble; urgency=medium

  * Fix package name in symbols file.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 19 Apr 2024 19:18:13 +0200

parasail (2.6.2+dfsg-1ubuntu1) noble; urgency=medium

  * Rename libparasail8 package as although it is not affected by the
    time_t transition to 64-bits, it is affected by the LFS migration
    which is implied by the time_t changes.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 19 Apr 2024 12:09:52 +1200

parasail (2.6.2+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * 0001-Use-system-libs.patch: refresh.

 -- Étienne Mollier <emollier@debian.org>  Thu, 17 Aug 2023 13:39:18 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: parasail
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Nilesh Patra <nilesh@debian.org>,
            Étienne Mollier <emollier@debian.org>
 Section: science
@@ -8,7 +9,7 @@
                d-shlibs,
                libhts-dev,
                libsimde-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/parasail
 Vcs-Git: https://salsa.debian.org/med-team/parasail.git
 Homepage: https://github.com/jeffdaily/parasail
@@ -27,6 +28,10 @@
  sequence alignment algorithm.
 
 Package: libparasail8
+Provides: ${t64:Provides}
+Replaces: libparasail8t64
+Breaks: libparasail8t64 (<< ${source:Version})
+Conflicts: libparasail8t64 (<< ${source:Version})
 Architecture: any
 Section: libs
 Multi-Arch: same

=== debian/watch ===
version=4
opts=\
repacksuffix=+dfsg,\
repack,compression=xz,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.\d+)?$//,\
filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/parasail-$1\.tar\.gz/ \
  https://github.com/jeffdaily/parasail/tags .*/v?(\d[\d.]+)\.tar\.gz
